function that=execute(fp,varargin)
%implement arg1-arg2
% if nargin==0
%     a=deflatev(1:8);
%     res=execute(@difmat,a,a);
%     return
% end
% function r=difmat(a,b)
% r=a-b;

for k=1:length(varargin)
    if ~strcmp(class(varargin{k}),'deflatev')
        error('In call "execute" all except first argument must be deflated vectors');
    end
    L=length(varargin{k});
    if k>1 && L~=LL
        error('In call "execute" all deflated vectors must have equal size');
    end
    LL=L;
end

that=emptycopy(varargin{1});
S=get(that,'segmentsize');
N=numel(that);
strt=1;
while strt<=N
    last=min(strt+S-1,N);
    rng=[strt;last]; %1 segment
    for k=1:length(varargin)
        data{k}=getclosedrange(varargin{k},rng);
    end
    if iscell(fp)
        result=feval(fp{1},fp{2:end},data{:});
    else
        result=feval(fp,data{:});
    end
    that=setclosedrange(that,rng,result);
    strt=last+1;
end
