function obj=loadobj(obj)
if isstruct(obj)
    for k=1:length(obj.segment)
        segarray(k)=converSegment(obj.segment(k));
    end 
    obj.segment=segarray;
    disp('Add new field to object');
    if ~isfield(obj,'emptyvalue')
        %older objects do not have the field "emptyvalue"
        %it is important that this value is of the right format, because it
        %is used to initialize response vectors
        switch obj.dataclass
            case 'char'
                obj.emptyvalue=' ';
            case 'logical'
                obj.emptyvalue=false;
            otherwise
                obj.emptyvalue=zeros(1,1,obj.dataclass);
        end
    end
    obj=deflatev(obj);
end

function segment=converSegment(oldsegment)
if isfield(oldsegment,'dat');
    %do not change
    segment=oldsegment;
    return
end

%create a new datastructure
segment.dat   = oldsegment.data; 
segment.range = uint32([1 oldsegment.dataSize(1)]);



