function that=mtimes(arg1,arg2)

if strcmp(class(arg1),'deflatev')
    factor=arg2;
    vector=arg1;
else
    factor=arg1;
    vector=arg2;
end

if strcmp(class(factor),'deflatev') ||~isnumeric(factor) ||length(factor)>1
    error('method mtimes allows only multiplication with scalar');
end

that=emptycopy(vector);

S=get(vector,'segmentsize');
N=numel(vector);
strt=1;
while strt<=N
    last=min(strt+S-1,N);
    rng=[strt;last]; %1 segment
    data=getclosedrange(vector,rng);
    that=setclosedrange(that,rng,factor*data);
    strt=last+1;
end
    
